from csv import reader

long_Ind = {9:0, 11:1,13:2,25:3,26:4,27:5,28:6,32:7,35:8,42:9}

SPE = ( 'Humanités',
        'Littérature',
        'Mathématiques',
        'Arts - Cinéma Audiovisuel',
        'Littérature et Philosophie',
        'Sciences et Vie de la Terre',
           
        'Sciences Physiques et Chimie',
        'Sciences Economiques et Sociales',
            
        'Numérique et Sciences Informatiques',
        'Histoire-Géographie et Sciences Politiques',
        'Langue et Civilisation Anglaises')
       
 

OPT = ('Pas d\'options',
       'Maths complémentaires',
       'Maths expertes',
       'Droit et grands enjeux du monde contemporain')
       
#--------------------------------------------------------
        
def creationTableau2D(nomFichier):
    """
    lit un fichier csv et crée une liste de listes 
    chaque liste correspond à une ligne du fichier csv
    
    paramètres:
    ----------
    nomFichier : string
                chaine de caractères nommant un fichier .csv
 
    résultat:
    ---------
    list
        une liste de listes (une ligne du fichier .csv)
    """

    tab2D = []
    with open(nomFichier,"r",newline='',encoding='utf-8') as fichier:
        donnees = reader(fichier,delimiter=';')
        for ligne in donnees:
            tab2D.append(ligne)
    return tab2D

def affiche(nbLignes,tableau):
    """
    affiche les nbLignes premières listes de tableau 
    
    paramètres:
    ----------
    nbLignes : int
              Les premières lignes que l'on veut afficher
    
    tableau : list
              Une liste de liste
              
    résultat:
    ---------
    None
    """
    for i in range(nbLignes):
        print(tableau[i])
      
         
def effectifsSpeTerminale(tableau):
    """
    calcule les effectifs des spécialités en Terminale
    
    paramètres:
    ----------
    tableau : list
             liste des choix des élèves
 
    résultat:
    ---------
    list
        une liste des effectifs des spécialités 
    """
    effectifs = [0]*11
    
    return effectifs

def effectifsOptTerminale(tableau):
    """
    à compléter
    
    """
    effectifs = [0]*4
    
    return effectifs


            
def tauxDeContinuite(tableau):
    """
    calcule pour chaque spécialité le taux de continuité
    définit comme le rapport (effectif en Terminale)/(effectif en première)
    Comme un taux de réussite à un examen = reçus/inscrits
    
    
    paramètres:
    ----------
    tableau : list
             liste des choix des élèves
 
    résultat:
    ---------
    tuple
        une liste des effectifs des spécialités en Term,une liste de taux de continuité
    """
    effectifs = [0]*11
    taux = [1]*11
    # à compléter
    for j in range(11):
        taux[j] = effectifs[j]/taux[j]
    return effectifs, taux
    
    
def bilan(tableau):
    """
    affiche les effectifs des spécialités
    affiche les effectifs des options
    affiche les taux de continuité
    
    paramètres:
    ----------
    tableau
 
    résultat:
    ---------
    None
    """
    effSpe = []
    taux = [0]*11
    effOpt = []
    
    effSpe = effectifsSpeTerminale(tableau)
    #effSpe,taux = tauxDeContinuite(tableau)
    effOpt = effectifsOptTerminale(tableau)
    
    print("------EFFECTIFS DES SPECIALITES----------------------")
    print()
    for i in range(11):
        print(SPE[i],' '*(50 -len(SPE[i])),'{:3d}'.format(effSpe[i]))
    print()
    print("------EFFECTIFS DES OPTIONS--------------------------") 
    print()
    for i in range(4):
        print(OPT[i],' '*(50 -len(OPT[i])),'{:3d}'.format(effOpt[i]))
    print()
    print("------TAUX DE CONTINUITE-----------------------------")
    print()
    for i in range(11):
        print(SPE[i],' '*(50 -len(SPE[i])),'{:.2f}'.format(taux[i]))
    
   
        
if __name__ == "__main__":
    lyceens = []
    lyceens = creationTableau2D("terminale_20_21.csv")
    
    #affiche(100,lyceens)
    
    bilan(lyceens)

